//=========================================================================
//
//	FILE:				CP_Dialog_Main.cpp
//	
//						Copyright  2004. Ken Stahlman. All Rights Reserved.
//	
//	PURPOSE:			Application entry point for CP_Dialog demo app.
//	
//	HISTORY:			1st Version - August 2004.
//	
//	NOTES:				- none -
//
//	VERSION:			Current Revision: $Rev: 2 $
//						Latest Checkout:  $Date: 2005-08-30 22:28:44 -0700 (Tue, 30 Aug 2005) $
//
//=========================================================================

	// CP_Scrolling
#include "CP_Dialog_App.h"

	// CPLAT_Framework
#include "CP_Debugging.h"
#include "CP_Exceptions.h"
#include "CP_FrameworkFlags.h"
#include "CP_Startup.h"
	
#if TARGET_OS_MAC
	#if TARGET_CC_METROWERKS && CP_Debug
		#include <DataViewer.h>
	#endif	// TARGET_CC_METROWERKS && CP_Debug
#endif

#if TARGET_OS_MAC || TARGET_OS_LINUX
	int main( int argc, char *argv[] )
#else if TARGET_OS_WIN32
	int WINAPI WinMain( HINSTANCE hInst, HINSTANCE hPreInst, LPSTR lpszCmdLine, int nCmdShow )
#endif
{
	#if TARGET_OS_MAC
		#if TARGET_CC_METROWERKS && CP_Debug
			DataViewLibInit();
		#endif	// TARGET_CC_METROWERKS && CP_Debug
	#endif
	
	try
	{	
		#if TARGET_OS_MAC || TARGET_OS_LINUX
			std::auto_ptr<CPLAT::CP_Startup>		platformStartup( CP_new CPLAT::CP_Startup( argc, argv ) );
		#else
			std::auto_ptr<CPLAT::CP_Startup>		platformStartup( CP_new CPLAT::CP_Startup( hInst, hPreInst, lpszCmdLine, nCmdShow  ) );
		#endif
		
		CP_Dialog_Application		application;
		application.Run();	
	}
	catch(...)
	{
	}
	
	return( 0 );
}
