//=========================================================================
//
//	FILE:				CP_UIClasses_App.h
//	
//						Copyright  2004. Ken Stahlman. All Rights Reserved.
//	
//	PURPOSE:			Application class for the CP_UIClasses demo.
//	
//	HISTORY:			1st Version - August 2004.
//	
//	NOTES:				- none -
//
//	VERSION:			Current Revision: $Rev: 4 $
//						Latest Checkout:  $Date: 2005-07-17 20:28:23 -0700 (Sun, 17 Jul 2005) $
//
//=========================================================================
#ifndef _H_CP_UIClasses_Application
#define _H_CP_UIClasses_Application
#ifndef TARGET_OS_LINUX
	#pragma once
#endif

	// CPLAT_Framework
#include "CP_Application.h"
#include "CP_DocumentPolicy_None.h"
#include "CP_OSStatus.h"
#include "CP_PrintPolicy_None.h"
#include "CP_Types.h"
#include "CP_UndoPolicy_None.h"

/*!
*	@class		CP_UIClasses_Application
*	@brief		Application class for the UIClasses demo.
*/
class CP_UIClasses_Application : public CPLAT::CP_Application<CPLAT::CP_DocumentPolicy_None, CPLAT::CP_PrintPolicy_None, CPLAT::CP_UndoPolicy_None>
{
public:
	//! @name Constructor / Destructor
	//@{
	//! Constructor.
										CP_UIClasses_Application();
	//! Destructor.
	virtual								~CP_UIClasses_Application() throw();
	//@}

protected:
	//! @name AboutBox
	//@{
	virtual	CPLAT::CP_String			GetAboutBoxDescription() const;
	//@}

	//! @name Commands
	//@{
	virtual	void						HandleNewUpdateCommandStatusCommand(
												CPLAT::CP_CommandStatus& inOutCommandStatus,
												bool& /*inOutWasHandled*/,
												CPLAT::CP_CommandNo& /*inCommandNo*/ )					{ inOutCommandStatus.SetIsEnabled( true ); }
	virtual	void						HandleNewCommand(
												CPLAT::OSStatus& inOutStatus,
												CPLAT::CP_CommandNo& inCommandNo );

	virtual	void						HandleOpenApplication();
	//@}

private:
	typedef CPLAT::CP_Application<CPLAT::CP_DocumentPolicy_None, CPLAT::CP_PrintPolicy_None, CPLAT::CP_UndoPolicy_None>	inherited;

	//! @name Command Handlers
	//@{
			void						CreateMainWindow(
												CPLAT::OSStatus& inOutStatus,
												CPLAT::CP_CommandNo& inCommandNo );
	//@}

	//! @name Views
	//@{
			CPLAT::CP_View				*CreateButtonView( CPLAT::CP_View *inSuperview );
			CPLAT::CP_View 				*CreateTracksView( CPLAT::CP_View *inSuperview );
			CPLAT::CP_View 				*CreateGroupsView( CPLAT::CP_View *inSuperview );
			CPLAT::CP_View 				*CreateMiscView( CPLAT::CP_View *inSuperview );
	//@}

	//! @name PopupMenus
	//@{
			void						InitPopupMenuCommands();
			void						HandlePopupCommand(
												CPLAT::OSStatus& inOutStatus,
												CPLAT::CP_CommandNo& inCommandNo );
	//@}

	//! @name Slots
	//@{
			void						ControlClicked(
												CPLAT::CP_DataValueHolder& inValue,
												CPLAT::OSStatus& inOutStatus );
	//@}

	// class data
protected:

//========================================================================
// Platform specific routines
//========================================================================
#if TARGET_OS_MAC
#endif

#if TARGET_OS_WIN32
#endif

#if TARGET_OS_LINUX
#endif
};

#endif	// _H_CP_UIClasses_Application

