//=========================================================================
//
//	FILE:				CP_UIClasses_Linux_Resources.h
//	
//						Copyright  2004. Ken Stahlman. All Rights Reserved.
//	
//	PURPOSE:			Resources used in the Linux version of the UIClasses
//						demo app.
//	
//	HISTORY:			1st Version - August 2004.
//	
//	NOTES:				- none -
//
//	VERSION:			Current Revision: $Rev: 7 $
//						Latest Checkout:  $Date: 2005-08-30 20:34:07 -0700 (Tue, 30 Aug 2005) $
//
//=========================================================================

#if TARGET_OS_LINUX

	// CPLAT_Framework
#include "CP_Data_ResourceTypes.h"
#include "CP_FrameworkResources.h"
#include "CP_FrameworkStructures_Linux.h"
#include "CP_OSTypes.h"
#include "CP_Resource_Imp_Linux.h"
	
	// Main menus
#include "CP_UIClasses_Menus_Linux.cpp"

	// Images
#include "3DRings.xpm"
#include "TestIcon.xpm"

	void InitLinuxResources()
	{
		CPLAT::FourCharCode			resType = CPLAT::kMenuBarResourceType;
		SInt16						resID = CPLAT::kCP_DefaultMennuBarID;
		CPLAT::OSHandle				resourceData = (CPLAT::OSHandle) &gMenuBar_Main;

		CP_ADD_RESOURCE_ENTRY( resType, resID, resourceData );

			// Pictures
		CP_ADD_RESOURCE_ENTRY( CPLAT::kPictureResourceType, 1000, DRings_xpm );

			// Icons
		CP_ADD_RESOURCE_ENTRY( CPLAT::kIconResourceType, 1000, TestIcon );
	}

#endif	// TARGET_OS_LINUX
