//=========================================================================
//
//	FILE:				UI_Classes_Main.cpp
//	
//						Copyright  2004. Ken Stahlman. All Rights Reserved.
//	
//	PURPOSE:			Application entry point for CP_UIClasses demo app.
//	
//	HISTORY:			1st Version - August 2004.
//	
//	NOTES:				- none -
//
//	VERSION:			Current Revision: $Rev: 3 $
//						Latest Checkout:  $Date: 2005-01-04 19:36:17 -0800 (Tue, 04 Jan 2005) $
//
//=========================================================================

	// CP_UIClasses
#include "CP_UIClasses_Main.h"
#include "CP_UIClasses_App.h"

	// CPLAT_Framework
#include "CP_Data_ResourceTypes.h"
#include "CP_Debugging.h"
#include "CP_Exceptions.h"
#include "CP_FrameworkFlags.h"
#include "CP_FrameworkResources.h"
#include "CP_LinuxResources.h"
#include "CP_Startup.h"
	
#if TARGET_OS_MAC
	#if TARGET_CC_METROWERKS && CP_Debug
		#include <DataViewer.h>
	#endif	// TARGET_CC_METROWERKS && CP_Debug
#endif

#if TARGET_OS_LINUX
	#include "CP_FrameworkStructures_Linux.h"
	#include "CP_Resource_Imp_Linux.h"

		// Images
//	#include "3DRings.xpm"
//	#include "TestIcon.xpm"
	
	extern  void InitLinuxResources();

	extern CPLAT::CP_S_MenuItems_Linux	gMenuBar_Main[];
	extern CPLAT::CP_S_MenuItems_Linux	gPopupMenu[];
#endif

#if TARGET_OS_MAC || TARGET_OS_LINUX
	int main( int argc, char *argv[] )
#else if TARGET_OS_WIN32
	int WINAPI WinMain( HINSTANCE hInst, HINSTANCE hPreInst, LPSTR lpszCmdLine, int nCmdShow )
#endif
{
	#if TARGET_OS_MAC
		#if TARGET_CC_METROWERKS && CP_Debug
			DataViewLibInit();
		#endif	// TARGET_CC_METROWERKS && CP_Debug
	#endif
	
	try
	{	
		#if TARGET_OS_LINUX
			InitLinuxResources();
		#endif

		#if TARGET_OS_MAC || TARGET_OS_LINUX
			std::auto_ptr<CPLAT::CP_Startup>		platformStartup( CP_new CPLAT::CP_Startup( argc, argv ) );
		#else
			std::auto_ptr<CPLAT::CP_Startup>		platformStartup( CP_new CPLAT::CP_Startup( hInst, hPreInst, lpszCmdLine, nCmdShow  ) );
		#endif
		
		CP_UIClasses_Application		application;
		application.Run();	
	}
	catch(...)
	{
	}
	
	return( 0 );
}

#if TARGET_OS_LINUX
	void InitLinuxResources()
	{
		CPLAT::OSHandle					resourceData = NULL;

			// Menu bar
		resourceData = (CPLAT::OSHandle) &gMenuBar_Main;
		CP_ADD_RESOURCE_ENTRY( CPLAT::kMenuBarResourceType, CPLAT::kCP_DefaultMenuBarID, resourceData );

			/// Menu
		resourceData = (CPLAT::OSHandle) &gPopupMenu;
		CP_ADD_RESOURCE_ENTRY( CPLAT::kMenuResourceType, 1000, resourceData );

			// Pictures
		//CP_ADD_RESOURCE_ENTRY( CPLAT::kPictureResourceType, 1000, DRings_xpm );

			// Icons
		//CP_ADD_RESOURCE_ENTRY( CPLAT::kIconResourceType, 1000, TestIcon );
	}
#endif	// TARGET_OS_LINUX
