//=========================================================================
//
//	FILE:				CP_Action.cpp
//	
//						Copyright  2004. Ken Stahlman. All Rights Reserved.
//	
//	PURPOSE:			Base class for performing a sequence of operations in
//						CPLAT, such as Undo / Redo.
//	
//	HISTORY:			1st Version - August 2004.
//	
//	NOTES:				- none -
//
//	VERSION:			Current Revision: $Rev: 2 $
//						Latest Checkout:  $Date: 2004-12-21 19:40:38 -0800 (Tue, 21 Dec 2004) $
//
//=========================================================================
#ifndef _H_CP_Action
#define _H_CP_Action
#ifndef TARGET_OS_LINUX
	#pragma once
#endif

	// CPLAT_Framework
#include "CP_Object.h"
#include "CP_Types.h"

CPLAT_Begin_Namespace_CPLAT

enum {
	kEventParamAction   = 'CPAC'
};

/*!
*	@class		CP_Action
*	@brief		Base class for performing a sequence of operations in CPLAT, such as Undo / Redo.
*/
class CP_EXPORT CP_Action
{
public:
	//! @name Constructor / Destructor
	//@{
	//! Constructor.
										CP_Action();
	//! Destructor.
	virtual								~CP_Action();
	//@}

	//! @name Perform
	//@{
										/*!
										*	Performs the action. Subclasses need to override.
										*
										*	@exception	none
										*	
										*	@return		bool			Result of the action. The default
										*								just returns false.
										*/
	virtual	bool						DoRedo()									{ return( false ); }
	//@}

	// class data
protected:

//========================================================================
// Platform specific routines
//========================================================================
#if TARGET_OS_MAC
#endif

#if TARGET_OS_WIN32
#endif

#if TARGET_OS_LINUX
#endif
};

CPLAT_End_Namespace_CPLAT

#endif	// _H_CP_Action


