/*
=========================================================================

	FILE:		CP_Base64Encoder.h
	
				Copyright  1999-2003. Ken Stahlman. All Rights Reserved.
	
	PURPOSE:	CP_Encoder object to encode data in Base64 format.
	
	HISTORY:	1st Version - August 2000.
	
	NOTES:		- none -

	VERSION:	Current Revision: $Revision: 106 $
				Latest Checkout:  $Date: 2005-03-21 15:03:06 -0800 (Mon, 21 Mar 2005) $

=========================================================================
*/
#ifndef _H_CP_Base64Encoder
#define _H_CP_Base64Encoder
#ifndef TARGET_OS_LINUX
	#pragma once
#endif

	// CPLAT_Framework
#include "CP_DataEncoder.h"

CPLAT_Begin_Namespace_CPLAT

//!  CP_Base64Encoder
/*!
  The CP_Base64Encoder is an object of type CP_DataEncoder that encodes / decodes data
  contained in a CP_HandleBlock object in Base64 encoding. Can be sed with the internet
  protocol classes to send / receive data.
  \sa CP_DataEncoder, CP_HandleBlock.
*/
class CP_EXPORT CP_Base64Encoder : public CP_DataEncoder
{
public: 
											// Construction / destruction
										CP_Base64Encoder();
	virtual								~CP_Base64Encoder();
	
	virtual	UInt32						GetEncodedSize( UInt32 inOriginalSize );

	virtual	bool						Encode( const CP_HandleBlock& inData );

	virtual	bool						Decode( const CP_HandleBlock& inData );

	// Data members
protected:
	static char			gBase64Table[];
};

CPLAT_End_Namespace_CPLAT

#endif	// _H_CP_Base64Encoder
