//=========================================================================
//
//	FILE:				CP_Events.h
//	
//						Copyright  2004. Ken Stahlman. All Rights Reserved.
//	
//	PURPOSE:			Definitions for varous CPLAT event types. These are
//						similiar to the definitions used for Carbon and Window
//						events, but are CPLAT platform specific.
//	
//	HISTORY:			1st Version - August 2004.
//	
//	NOTES:				- none -
//
//	VERSION:			Current Revision: $Rev: 2 $
//						Latest Checkout:  $Date: 2004-12-21 19:40:38 -0800 (Tue, 21 Dec 2004) $
//
//=========================================================================
#ifndef _H_CP_Events
#define _H_CP_Events
#ifndef TARGET_OS_LINUX
	#pragma once
#endif

	// CPLAT_Framework
#include "CP_Event.h"
#include "CP_Events_Defines.h"
#include "CP_UndoAction.h"

CPLAT_Begin_Namespace_CPLAT

#if TARGET_CC_METROWERKS
#pragma mark -
#pragma mark === kCP_EventClassAction Events ==
#pragma mark -
#endif

template <> class CP_Event<kCP_EventClassAction, kCP_Event_UndoAction> : public CP_Event_Base
{
public:
	//! @name Constructor / Destructor
	//@{
	//! Constructor.
										CP_Event();
										CP_Event( CP_Event_Base& inEvent );
	//@}

	//! @name Event Info
	//@{
				void					ReturnInfo();
	//@}
	
	// class data
	CP_UndoAction						*fUndoAction;
};

CPLAT_End_Namespace_CPLAT

#endif	// _H_CP_Events

