//=========================================================================
//
//	FILE:				CP_Resource.h
//	
//						Copyright  2004. Ken Stahlman. All Rights Reserved.
//	
//	PURPOSE:			A class for dealing with a platforms resources.
//	
//	HISTORY:			1st Version - August 2004.
//	
//	NOTES:				- none -
//
//	VERSION:			Current Revision: $Rev: 2 $
//						Latest Checkout:  $Date: 2004-12-21 19:40:38 -0800 (Tue, 21 Dec 2004) $
//
//=========================================================================
#ifndef _H_CP_Resource
#define _H_CP_Resource
#if ! TARGET_OS_LINUX
	#pragma once
#endif

	// CPLAT_Framework
#include "CP_OSTypes.h"
#include "CP_Types.h"

CPLAT_Begin_Namespace_CPLAT

/*!
*	@class		CP_Resource
*	@brief		A class for dealing with a platforms resources.
*/
class CP_EXPORT CP_Resource
{
public:
	//! @name Constructor / Destructor
	//@{
	//! Constructor.
										CP_Resource();					
										CP_Resource(
												FourCharCode inResType,
												SInt16 inResID );
	//! Destructor.
	virtual								~CP_Resource();
	//@}
												
	//! @name Getters
	//@{
			OSHandle					GetResourceData(
												FourCharCode inResType,
												SInt16 inResID );
	//@}

	//! @name Accessors
	//@{
										/*! Return the resource as a MacOS Handle. */
			OSHandle					GetOSHandle()							{ return( fResourceH ); }
			
										/*! Return the resource as a MacOS Handle. */
			operator 					OSHandle()								{ return( fResourceH ); }
	//@}

	// class data
protected:
	OSHandle							fResourceH;			/*! Resource handle data. */
	
//========================================================================
// Platform specific routines
//========================================================================
#if TARGET_OS_MAC
public:
#endif

#if TARGET_OS_WIN32
#endif

#if TARGET_OS_LINUX
#endif
};

CPLAT_End_Namespace_CPLAT

#endif	// _H_Resource

