//=========================================================================
//
//	FILE:				CP_ScritableObject.h
//	
//						Copyright  2004. Ken Stahlman. All Rights Reserved.
//	
//	PURPOSE:			Base class for objects that provide scripting support.
//						This class inherits from CP_ScriptableObject_Imp which
//						provides the basis of OS scripting support in an object.
//	
//	HISTORY:			1st Version - August 2004.
//	
//	NOTES:				- none -
//
//	VERSION:			Current Revision: $Rev: 2 $
//						Latest Checkout:  $Date: 2004-12-21 19:40:38 -0800 (Tue, 21 Dec 2004) $
//
//=========================================================================
#ifndef _H_CP_ScritableObject
#define _H_CP_ScritableObject
#ifndef TARGET_OS_LINUX
	#pragma once
#endif

	// CPLAT_Framework
#include "CP_ScriptableObject_Imp_AE.h"
#include "CP_ScriptableObject_Imp_Win.h"

#if TARGET_OS_LINUX
	#include "CP_ScriptableObject_Imp_Gtk.h"
#endif

CPLAT_Begin_Namespace_CPLAT

class CP_EXPORT CP_ScriptableObject : public CP_ScriptableObject_Imp
{
public:
											// Construction / destruction
	virtual								~CP_ScriptableObject() throw();
			
protected:
											// Construction / destruction
										CP_ScriptableObject();

	// class data
protected:
	
//========================================================================
// Platform specific routines
//========================================================================
#if TARGET_OS_MAC
protected:
#endif

#if TARGET_OS_WIN32
#endif

#if TARGET_OS_LINUX
#endif
};

CPLAT_End_Namespace_CPLAT

#endif	// _H_CP_ScritableObject

