//=========================================================================
//
//	FILE:				CP_View_Imp_Gtk.h
//	
//						Copyright  2004. Ken Stahlman. All Rights Reserved.
//	
//	PURPOSE:			Windows implementation of a CP_View.
//	
//	HISTORY:			1st Version - August 2004.
//	
//	NOTES:				- none -
//
//	VERSION:			Current Revision: $Rev: 160 $
//						Latest Checkout:  $Date: 2005-04-27 21:21:26 -0700 (Wed, 27 Apr 2005) $
//
//=========================================================================
#ifndef _H_CP_View_Imp_Gtk
#define _H_CP_View_Imp_Gtk
#ifndef TARGET_OS_LINUX
	#pragma once
#endif

#if TARGET_OS_LINUX

	// CPLAT_Framework
#include "CP_Canvas.h"
#include "CP_EventHandler.h"
#include "CP_Events_Defines.h"
#include "CP_M_Persist.h"
#include "CP_View_Imp_Base.h"
#include "CP_Point.h"
#include "CP_Region.h"
#include "CP_Size.h"
#include "CP_String.h"

CPLAT_Begin_Namespace_CPLAT

class CP_EXPORT CP_View_Imp_Gtk : public CP_View_Imp_Base, public CP_SigSlot::CP_SlotObject
{
public:
											// Construction / destruction
										CP_View_Imp_Gtk(
												CP_View_Imp *inOwnerViewImp,
												CP_View *inSuperview,
												const CP_Point& inUpperLeft,
												const CP_Size& inContentSize,
												bool inCreateImp = false );
	virtual								~CP_View_Imp_Gtk() throw();
			
	//! @name Appearance
	//@{
	virtual	void						Show();
	virtual	void						Hide();
	//@}

											// Events
			void						HandleDraw( CP_Event<kCP_GTK_EVENT, kCP_Event_Draw>& inDrawEvent );
			SInt16						HandleEvent( CP_Event_Base& inEvent );

	//! @name Drawing
	//@{
	virtual	CP_Canvas					SetupForDrawing();
	//@}
											// Getters
	virtual	CP_EventHandler&			GetEventHandler()												{ return( fEventHandler ); }

											// Initialization
			void						CreateGtkWidget(
												CP_View *inSuperviewconst,
												const CP_Point& inUpperLeft,
												const CP_Size& inContentSize );

protected:
											// Construction / destruction
										CP_View_Imp_Gtk();

			void						InitEventHandler( CP_EventHandler& inEventHandler );

	virtual	void						SetSizeAndPosition(
												GtkWidget *inGtkWidget,
												CP_View *inSuperview,
												const CP_Point& inLocation,
												const CP_Size& inSize );

private:

	// class data
protected:
	CP_EventHandler						fEventHandler;		/*! Class that handles all of the events for this windnow. */

	CP_Size								fSize;				/*! Size of the view */
};

CPLAT_End_Namespace_CPLAT

#endif	// TARGET_OS_LINUX

#endif	// _H_CP_View_Imp_Gtk

