//=========================================================================
//
//	FILE:				CP_View_Imp_GtkToolbar.h
//	
//						Copyright  2004. Ken Stahlman. All Rights Reserved.
//	
//	PURPOSE:			
//	
//	HISTORY:			1st Version - August 2004.
//	
//	NOTES:				- none -
//
//	VERSION:			Current Revision: $Rev: 2 $
//						Latest Checkout:  $Date: 2004-12-21 19:40:38 -0800 (Tue, 21 Dec 2004) $
//
//=========================================================================
#ifndef _H_CP_View_Imp_GtkToolbar
#define _H_CP_View_Imp_GtkToolbar
#ifndef TARGET_OS_LINUX
	#pragma once
#endif

#if TARGET_OS_LINUX

	// CPLAT_Framework
#include "CP_Structure_Defines.h"
#include "CP_View_Imp_Gtk.h"

CPLAT_Begin_Namespace_CPLAT

	// forward class declarations
class CP_View_Imp_GtkToolbar_Item;

class CP_EXPORT CP_View_Imp_GtkToolbar : public CP_View_Imp_Gtk
{
public:
									// Construction / destruction
								CP_View_Imp_GtkToolbar(
										CP_View_Imp *inOwnerViewImp,
										CP_View *inSuperview,
										const CP_Point& inUpperLeft,
										const CP_Size& inContentSize );
	virtual						~CP_View_Imp_GtkToolbar() throw();

	//! @name Toolbar Items
	//@{
			void				AddItem(
										const CP_String& inItemText,
										const CP_S_ViewContentInfo& inContentInfo,
										const CP_CommandNo inCommand );
	//@}

protected:
	//! @name Drawing
	//@{
	virtual	void				HandleDrawInCanvas(
										CP_Canvas& inCanvas,
										CP_Region& inUpdateArea );
	//@}

private:
			SInt16				GetNextItemHorPosition();

	// class data
protected:
};

class CP_EXPORT CP_View_Imp_GtkToolbar_Item : public CP_View_Imp_Gtk
{
public:
									// Construction / destruction
								CP_View_Imp_GtkToolbar_Item(
										CP_View_Imp *inOwnerViewImp,
										CP_View *inSuperview,
										const CP_Point& inUpperLeft,
										const CP_Size& inContentSize,
										const CP_String& inItemText,
										const CP_S_ViewContentInfo& inContentInfo );
	virtual						~CP_View_Imp_GtkToolbar_Item() throw();

protected:
	//! @name Drawing
	//@{
	virtual	void				HandleDrawInCanvas(
										CP_Canvas& inCanvas,
										CP_Region& inUpdateArea );
	//@}

private:
			CP_Rect				GetTextBounds( const CP_Rect& inBounds ) const;
			CP_Rect				GetImageBounds( const CP_Rect& inBounds ) const;
			
	// class data
protected:
	CP_String					fItemText;
	CP_S_ViewContentInfo		fContentInfo;
};

CPLAT_End_Namespace_CPLAT

#endif	// TARGET_OS_LINUX

#endif	// _H_CP_View_Imp_GtkToolbar

