//=========================================================================
//
//	FILE:				CP_CFURL.h
//	
//						Copyright  2004. Ken Stahlman. All Rights Reserved.
//	
//	PURPOSE:			A class to manage a MacOS CFURL.
//	
//	HISTORY:			1st Version - August 2004.
//	
//	NOTES:				- none -
//
//	VERSION:			Current Revision: $Rev: 271 $
//						Latest Checkout:  $Date: 2005-09-06 19:24:58 -0700 (Tue, 06 Sep 2005) $
//
//=========================================================================
#ifndef _H_CP_CFURL
#define _H_CP_CFURL
#ifndef TARGET_OS_LINUX
	#pragma once
#endif

#if TARGET_OS_MAC

	// CPLAT_Framework
#include "CP_FileSystemSpec.h"
#include "CP_ResourcePtr.h"

CPLAT_Begin_Namespace_CPLAT

/*!
*	@class	CP_CFURL
*	@brief	A class to manage a MacOS CFURL.
*/
class CP_EXPORT CP_CFURL
{
public:
	//! @name Constructor / Destructor
	//@{
	//! Constructor.
										CP_CFURL( CP_ResourcePtr<CFURLRef> inCFURLRef );
										CP_CFURL( const CP_String& inCFURLString );
										CP_CFURL( const CP_CFURL& inCFURL );
	//! Destructor.
	virtual								~CP_CFURL() throw();
	//@}
			
	//! @name Getters
	//@{
			CP_FileSystemSpec			GetFileSpec();
	
										/*!
										*	Return the CFURL for this object.
										*
										*	@exception	none
										*	
										*	@return		CFURL		The CFURL for this object.
										*/
			CFURLRef					GetCFURL()									{ return( fCFURL ); }
			FSRef						GetFSRef();
	//@}

	//! @name operators
	//@{
			CP_CFURL&					operator =( const CP_CFURL& inCFURL );
	//@}

	//! @name Tester
	//@{
			bool						IsValid();
			bool						IsDirectory();
	//@}

protected:

	// class data
protected:
	CFURLRef							fCFURL;		/*! The CFURL we manage. */
};

CPLAT_End_Namespace_CPLAT

#endif  // TARGET_OS_MAC

#endif	// _H_CP_CFURL

