//=========================================================================
//
//	FILE:				CP_CGDataProvider.h
//	
//						Copyright  2005. Ken Stahlman. All Rights Reserved.
//	
//	PURPOSE:			A class to handle the CGDataProviderRef.
//	
//	HISTORY:			1st Version - February 2005.
//	
//	NOTES:				- none -
//
//	VERSION:			Current Revision: $Rev: 271 $
//						Latest Checkout:  $Date: 2005-09-06 19:24:58 -0700 (Tue, 06 Sep 2005) $
//
//=========================================================================
#ifndef _H_CP_CGDataProvider
#define _H_CP_CGDataProvider
#ifndef TARGET_OS_LINUX
	#pragma once
#endif

#if TARGET_OS_MAC && TARGET_RT_MAC_MACHO

	// CPLAT_Framework
#include "CP_CGColorSpace.h"

CPLAT_Begin_Namespace_CPLAT

/*!
*	@class		CP_CGDataProvider
*	@brief		A class to handle the CGDataProviderRef.
*/
class CP_EXPORT CP_CGDataProvider
{
public:
	//! @name Constructor / Destructor
	//@{
	//! Constructor.
										CP_CGDataProvider(
												SInt32 inWidth,
												SInt32 inHeight,
												void *inData );
	//! Destructor.
	virtual								~CP_CGDataProvider() throw();
	//@}

	//! @name Getters
	//@{
										/*!
										*	Return the CGDataProviderRef for this object.
										*	
										*	@exception	none
										*	
										*	@return		CGDataProviderRef		The CGDataProviderRef for this object.
										*/
			CGDataProviderRef			GetDataProviderRef() const				{ return( fCGDataProvider ); }
	//@}

protected:

private:
	static void							CGDataProviderFreeFunction(
												void *inClientData,
												const void *inData,
												size_t inSize );
			
	// class data
private:
	CGDataProviderRef					fCGDataProvider;		/* ! The CGDataProviderRef for this object. */
	void								*fData;					/* ! The data we are managing. */
};

CPLAT_End_Namespace_CPLAT

#endif	// TARGET_OS_MAC && TARGET_RT_MAC_MACHO

#endif	// _H_CP_CGDataProvider

