//=========================================================================
//
//	FILE:				CP_View_Imp_HIScroller.h
//	
//						Copyright  2004. Ken Stahlman. All Rights Reserved.
//	
//	PURPOSE:			DESCRIBE CLASS HERE
//	
//	HISTORY:			1st Version - August 2004.
//	
//	NOTES:				- none -
//
//	VERSION:			Current Revision: $Rev: 263 $
//						Latest Checkout:  $Date: 2005-08-28 13:10:16 -0700 (Sun, 28 Aug 2005) $
//
//=========================================================================
#ifndef _H_CP_View_Imp_HIScroller
#define _H_CP_View_Imp_HIScroller
#ifndef TARGET_OS_LINUX
	#pragma once
#endif

#if TARGET_API_MAC_CARBON && TARGET_RT_MAC_MACHO && MAC_OS_X_VERSION_MAX_ALLOWED >= 1020

	// CPLAT_Framework
#include "CP_ScrollableView.h"
#include "CP_SignalSlot.h"
#include "CP_View_Imp_HIView.h"

CPLAT_Begin_Namespace_CPLAT

class CP_EXPORT CP_View_Imp_HIScroller : public CP_View_Imp_HIView
{
public:
	//! @name Constructor / Destructor
	//@{
	//! Constructor.
										CP_View_Imp_HIScroller(
												CP_View_Imp *inOwnerViewImp,
												CP_View *inSuperview,
												const CP_Point& inUpperLeft,
												const CP_Size& inContentSize,
												bool inHasHorizontalScrollBar = true,
												bool inHasVerticalScrollBar = true,
												bool inHasGrowBoxSpace = true );
	//! Destructor.
	virtual								~CP_View_Imp_HIScroller() throw();
	//@}

			HIViewRef					GetOSControl()										{ return( fScrollView ); }

	virtual	CP_Rect						GetContentBounds();

			void						HandleSetScrollingView( CP_ScrollableView *inScrollableView );

			void						HandleBoundsChanged(
												const CP_Rect& inPreviousBounds,
												const CP_Rect& inNewBounds );

	virtual	void						SetPortBounds( const CP_Rect& inBounds );

	//! @name Slots
	//@{
	virtual	void						ImageBoundsChanged(
												CP_DataValueHolder& inValue,
												OSStatus& inOutStatus );
	//@}

protected:

private:
			void						Init(
												CP_View_Imp *inOwnerViewImp,
												const CP_Point& inLocation,
												const CP_Size& inContentSize,
												bool inHasHorizontalScrollBar = true,
												bool inHasVerticalScrollBar = true,
												bool inHasGrowBoxSpace = true );

	// class data
protected:
	HIViewRef							fScrollView;			/*! HIViewRef for this scroller */
	SInt16								fScrollBarSize;			/*! Size of the scroll bars, either normal or small in pixels */
};
	
CPLAT_End_Namespace_CPLAT

#endif	// TARGET_API_MAC_CARBON && TARGET_RT_MAC_MACHO && MAC_OS_X_VERSION_MAX_ALLOWED >= 1020

#endif	// _H_CP_View_Imp_HIScroller

