//=========================================================================
//
//	FILE:				CP_Idler.h
//	
//						Copyright  2004. Ken Stahlman. All Rights Reserved.
//	
//	PURPOSE:			Mix-in class that provides idle time handling via a CP_TimedTask.
//	
//	HISTORY:			1st Version - August 2004.
//	
//	NOTES:				- none -
//
//	VERSION:			Current Revision: $Rev: 160 $
//						Latest Checkout:  $Date: 2005-04-27 21:21:26 -0700 (Wed, 27 Apr 2005) $
//
//=========================================================================
#ifndef _H_CP_Idler
#define _H_CP_Idler
#ifndef TARGET_OS_LINUX
	#pragma once
#endif

	// CPLAT_Framework
#include "CP_TimedTask.h"

CPLAT_Begin_Namespace_CPLAT

/*!
*	@class		CP_Idler
*	@brief		Class that provides idle time handling via a CP_TimedTask.
*/
class CP_EXPORT CP_Idler : public CP_Object, public CP_SigSlot::CP_SlotObject
{
public:
	//! @name Constructor / Destructor
	//@{
	//! Constructor.
										CP_Idler();
	//! Destructor.
	virtual								~CP_Idler() throw();
	//@}

	//! @name Timer
	//@{
			void						StartIdleTimer();
			void						StopIdleTimer();
	//@}

protected:

private:
	//! @name Timer
	//@{
			void						TimerTask(
													CP_DataValueHolder& inDataValue,
													OSStatus& inOSStatus );
	//@}

	// class data
protected:
	CP_TimedTask						*fIdleTimer;
	
		// Signals
	CP_DataValueSignal					fHandleTimeSignal;	/*! Signal sent when the value changes. */

//========================================================================
// Platform specific routines
//========================================================================
#if TARGET_OS_MAC
#endif

#if TARGET_OS_WIN32
#endif

#if TARGET_OS_LINUX
#endif
};

CPLAT_End_Namespace_CPLAT

#endif	// _H_CP_Idler

