//=========================================================================
//
//	FILE:				CP_ViewBackground.h
//	
//						Copyright  2004. Ken Stahlman. All Rights Reserved.
//	
//	PURPOSE:			A set of classes that can be attached to a CP_View object
//						to draw the views background.
//	
//	HISTORY:			1st Version - October 2004.
//	
//	NOTES:				- none -
//
//	VERSION:			Current Revision: $Rev: 2 $
//						Latest Checkout:  $Date: 2004-12-21 19:40:38 -0800 (Tue, 21 Dec 2004) $
//
//=========================================================================
#ifndef _H_CP_ViewBackground
#define _H_CP_ViewBackground
#ifndef TARGET_OS_LINUX
	#pragma once
#endif

	// CPLAT_Framework
#include "CP_Canvas.h"
#include "CP_M_Persist.h"
#include "CP_M_ReferenceCounted.h"
#include "CP_Region.h"

CPLAT_Begin_Namespace_CPLAT

class CP_EXPORT CP_ViewBackground : public CP_M_RefCounted, public CP_M_Persist
{
public:
	//! @name Constructor / Destructor
	//@{
	//! Constructor.
										CP_ViewBackground();
	//@}
	//! Destructor.
	virtual								~CP_ViewBackground() throw();
	//@}
			
	//! @name Drawing
	//@{
	virtual	void						Draw(
												CP_Canvas& inCanvas,
												CP_Region& inUpdateArea );
	//@}

	//! @name Persistance
	//@{
	static CP_M_Persist					*PersistCreator();
	//@}

protected:

	//! @name Persistance
	//@{
	virtual	void						OnInitPersist(
												CP_View *inSuperview,
												CP_DataValueList& inDataValueList );
	//@}

	// class data
protected:
	
//========================================================================
// Platform specific routines
//========================================================================
#if TARGET_OS_MAC
#endif

#if TARGET_OS_WIN32
#endif

#if TARGET_OS_LINUX
#endif
};

class CP_EXPORT CP_ViewBackground_White : public CP_ViewBackground
{
public:
	//! @name Constructor / Destructor
	//@{
	//! Constructor.
										CP_ViewBackground_White();
	//@}
	//! Destructor.
	virtual								~CP_ViewBackground_White() throw();
	//@}
			
	//! @name Drawing
	//@{
	virtual	void						Draw(
												CP_Canvas& inCanvas,
												CP_Region& inUpdateArea );
	//@}

	//! @name Persistance
	//@{
	static CP_M_Persist					*PersistCreator();
	//@}

protected:

	//! @name Persistance
	//@{
	virtual	void						OnInitPersist(
												CP_View *inSuperview,
												CP_DataValueList& inDataValueList );
	//@}

	// class data
protected:
	
//========================================================================
// Platform specific routines
//========================================================================
#if TARGET_OS_MAC
#endif

#if TARGET_OS_WIN32
#endif

#if TARGET_OS_LINUX
#endif
};

CPLAT_End_Namespace_CPLAT

#endif	// _H_CP_ViewBackground

