//=========================================================================
//
//	FILE:				CP_HRGN.h
//	
//						Copyright  2004. Ken Stahlman. All Rights Reserved.
//	
//	PURPOSE:			A class to manage a Windows HRGN.
//	
//	HISTORY:			1st Version - August 2004.
//	
//	NOTES:				- none -
//
//	VERSION:			Current Revision: $Rev: 2 $
//						Latest Checkout:  $Date: 2004-12-21 19:40:38 -0800 (Tue, 21 Dec 2004) $
//
//=========================================================================
#ifndef _H_CP_HRGN
#define _H_CP_HRGN
#ifndef TARGET_OS_LINUX
	#pragma once
#endif

#if TARGET_OS_WIN32

	// CPLAT_Framework
#include "CP_Types.h"

CPLAT_Begin_Namespace_CPLAT

/*!
*	@class		CP_HRGN
*	@brief		Class that provides a wrapper for the Windows HRGN.
*/
class CP_EXPORT CP_HRGN
{
public:
	//! @name Constructor / Destructor
	//@{
	//! Constructor.
										CP_HRGN( HRGN inHRGN );
										CP_HRGN( const CP_HRGN& inHRGN );
	//! Destructor.
	virtual								~CP_HRGN() throw();
	//@}
			
	//! @name Getters
	//@{
			HRGN						GetHRGN()									{ return( fHRGN ); }
	//@}

	//! @name operators
	//@{
			CP_HRGN&					operator =( const CP_HRGN& inHRGN );
	//@}

protected:

	// class data
protected:
	HRGN								fHRGN;		/*! The HRGN we manage. */
};

CPLAT_End_Namespace_CPLAT

#endif  // TARGET_OS_WIN32

#endif	// _H_CP_HRGN

