//=========================================================================
//
//	FILE:				CP_Debug_Win.h
//	
//						Copyright  2004. Ken Stahlman. All Rights Reserved.
//	
//	PURPOSE:			Header file to create a precompiled header for CPLAT
//						projects.
//	
//	HISTORY:			1st Version - August 2004.
//	
//	PLATFORM:			Windows
//	DEBUGGING:			Debug
//
//	VERSION:			Current Revision: $Rev: 226 $
//						Latest Checkout:  $Date: 2005-07-02 15:14:01 -0700 (Sat, 02 Jul 2005) $
//
//=========================================================================

// ===================================================================================
//	Platform build flags
// ===================================================================================
#define TARGET_OS_MAC						0
#define TARGET_API_MAC_CARBON				0

#define TARGET_OS_WIN32						1

#define TARGET_OS_LINUX						0

// ===================================================================================
//	Debugging flags
// ===================================================================================
#define CP_Debug							1
#define CP_Debug_Exceptions					1
#define CP_Debug_RecordMemoryAllocations	0
#define CP_Debug_UseCustomOperatorNew		1
#define CP_Debug_RecordOSCalls				0
#define CP_Debug_RecordMemoryAllocations	0

	// WinSDK
#ifndef TARGET_CC_MSVC
	#define _DEBUG								CP_Debug
#endif

// ===================================================================================
//	OS Environment
// ===================================================================================
#define STRICT								1
#define UNICODE								1
	
// ===================================================================================
//	Optional flags
// ===================================================================================
#define CP_Optional_GDIPlus					1		// Default is to use GDI+
#define CP_Optional_ThemeSupport_Windows	0		// Use theme support

// ===================================================================================
//	Namespace
// ===================================================================================
#define ENABLE_STD_NAMESPACE				1		// enable std namespace
	
// ===================================================================================
//	MSL Defines
// ===================================================================================
#if TARGET_CC_METROWERKS
	#include <ansi_prefix.win32.h>
#endif

#ifndef __dest_os
	#define __dest_os					__win32_os
#endif

// ===================================================================================
//	Window SDK includes
// ===================================================================================
#include <WinSock2.h>
#include <windows.h>
#include <tchar.h>

#undef min
#undef max

// ===================================================================================
//	CPLAT_Framework includes
// ===================================================================================
#include "CP_Types.h"
#include "CP_FrameworkFlags.h"

#include "UserPrefixFlags.h"

#include "CP_FrameworkHeaders.h"
